#!/usr/bin/ruby
# coding: utf-8

require 'tk'
require './solar_system_param'


NOrbitDiv = 181
JMax      =  64


# make a figure file
n = 0
sFigFN = "/tmp/dcl"
loop do
  sFigFN = "/tmp/" + $0 + "-" + n.to_s
  break if !File.exist?(sFigFN+".pdf") && !File.exist?(sFigFN+".gif")
  n += 1
end


def imgwindow( imgfn )

  winimg = TkToplevel.new
  winimg.title = 'Figure'
  button = TkButton.new( winimg )
  button.text = 'close'
  button.command proc{winimg.destroy}
  button.pack('side' => 'top')
  imggif = TkPhotoImage.new
  imggif.file = imgfn
  label = TkLabel.new( winimg )
  label.text = 'Figure'
  label.image = imggif
  label.place('height'=>imggif.height,'width'=>imggif.width, 'x'=>10, 'y'=>10)
  label.pack('side' => 'top')

end

iPlanet = 3-1
sSMAxis       = A_SMAxis[iPlanet]
sEccen        = A_Eccen[iPlanet]
sPerLon       = A_PerLon[iPlanet]
sTrYear       = A_TrYear[iPlanet]
sEpsOrb       = A_Obliq[iPlanet]
sPerLs        = A_PerLs[iPlanet]
sMLonAtEpoch  = A_MLonEp[iPlanet]



title = TkLabel.new
title.text = 'Distribution of insolation into a planet'
title.pack( 'side'=>'top' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

plotnum = TkVariable.new(1)
#
plot_name = TkLabel.new
plot_name.text = 'Figure'
plot_name.pack( 'side'=>'top' )
#
plot_frame = TkFrame.new.pack( 'side'=>'top' )
#
plot_button1 = TkRadioButton.new( plot_frame ) {
  text "Seasonal variation"
  value 1
  variable plotnum
  #  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}
#
plot_button2 = TkRadioButton.new( plot_frame ) {
  text "Annual mean"
  value 2
  variable plotnum
  #  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}


TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

eccen_frame = TkFrame.new.pack( 'side'=>'top' )
eccen_name = TkLabel.new( eccen_frame )
eccen_name.text = 'eccentricity (1): '
eccen_name.pack( 'side'=>'left' )
eccen_value = TkEntry.new( eccen_frame )
eccen_value.value = sEccen
eccen_value.pack( 'side'=>'right' )

perlon_frame = TkFrame.new.pack( 'side'=>'top' )
perlon_name = TkLabel.new( perlon_frame )
perlon_name.text = 'perihelion longitude (degree): '
perlon_name.pack( 'side'=>'left' )
perlon_value = TkEntry.new( perlon_frame )
perlon_value.value = sPerLon
perlon_value.pack( 'side'=>'right' )

tryear_frame = TkFrame.new.pack( 'side'=>'top' )
tryear_name = TkLabel.new( tryear_frame )
tryear_name.text = 'tropical year (Earth year): '
tryear_name.pack( 'side'=>'left' )
tryear_value = TkEntry.new( tryear_frame )
tryear_value.value = sTrYear
tryear_value.pack( 'side'=>'right' )

epsorb_frame = TkFrame.new.pack( 'side'=>'top' )
epsorb_name = TkLabel.new( epsorb_frame )
epsorb_name.text = 'obliquity (degree): '
epsorb_name.pack( 'side'=>'left' )
epsorb_value = TkEntry.new( epsorb_frame )
epsorb_value.value = sEpsOrb
epsorb_value.pack( 'side'=>'right' )

perls_frame = TkFrame.new.pack( 'side'=>'top' )
perls_name = TkLabel.new( perls_frame )
perls_name.text = 'perihelion longitude (degree): '
perls_name.pack( 'side'=>'left' )
perls_value = TkEntry.new( perls_frame )
perls_value.value = sPerLs
perls_value.pack( 'side'=>'right' )

mlonatep_frame = TkFrame.new.pack( 'side'=>'top' )
mlonatep_name = TkLabel.new( mlonatep_frame )
mlonatep_name.text = 'mean longitude at epoch (degree): '
mlonatep_name.pack( 'side'=>'left' )
mlonatep_value = TkEntry.new( mlonatep_frame )
mlonatep_value.value = sMLonAtEpoch
mlonatep_value.pack( 'side'=>'right' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

file_name = TkLabel.new
file_name.text = 'Temporary figure file (*.pdf, *.gif)'
file_name.pack( 'side'=>'top' )
file_frame = TkFrame.new.pack( 'side'=>'top' )
file_name = TkLabel.new( file_frame )
file_name.text = 'path:'
file_name.pack( 'side'=>'left' )
file_value = TkEntry.new( file_frame )
file_value.value = sFigFN
file_value.pack( 'side'=>'left' )
file_remove_var = TkVariable.new
file_remove_var.value = 1
file_button = TkCheckButton.new( file_frame ) {
  text "Remove figure file"
  onvalue = 1
  offvalue = 0
  variable file_remove_var
  pack( 'anchor'=>'w', 'side'=>'left' )
}


button_exec = TkButton.new
button_exec.text = 'execute'
button_exec.command{
  sSMAxis       = sSMAxis
  sEccen        = eccen_value.value.to_f
  sPerLon       = perlon_value.value.to_f
#sSecInAYear = tryear[iPlanet] * 365.0 * ( 60.0 * 60.0 * 24.0 )
  sSecInAYear   = tryear_value.value.to_f * 365.242191 * ( 60*60*24 )
  sEpsOrb       = epsorb_value.value.to_f
  sPerLs        = perls_value.value.to_f
  sMLonAtEpoch  = mlonatep_value.value.to_f
  sFigFN        = file_value.value
#  com = "ruby insolation_gui_core.rb "+FigFN+" "+plotnum.to_s+" "+sSMAxis.to_s+" "+sEccen.to_s+" "+sPerLon.to_s+" "+sSecInAYear.to_s+" "+sEpsOrb.to_s+" "+sPerLs.to_s+" "+sMLonAtEpoch.to_s
  com = "ruby insolation_ctl.rb "+sFigFN+" "+plotnum.to_s+" "+sSMAxis.to_s+" "+sEccen.to_s+" "+sPerLon.to_s+" "+sSecInAYear.to_s+" "+sEpsOrb.to_s+" "+sPerLs.to_s+" "+sMLonAtEpoch.to_s
  system( com )
  system( "convert -rotate 90 -background white -flatten "+sFigFN+".pdf "+sFigFN+".gif" )
  imgwindow( sFigFN+'.gif' )
  if file_remove_var.value.to_i == 1 then
    system( "rm "+sFigFN+".pdf" ) if File.exist?(sFigFN+".pdf")
    system( "rm "+sFigFN+".gif" ) if File.exist?(sFigFN+".gif")
  end
}
button_exec.pack( 'side' => 'left' )

#button_exec.bind( 'Button', proc {ebm_draw_temp} )
#button_exec.bind( 'Button', proc { showtext } )
#ebm_draw_temp if ARGV.size == 0


button_exit = TkButton.new
button_exit.text = 'exit'
button_exit.command = proc{ exit }
button_exit.pack( 'side' => 'right' )

Tk.mainloop
